'************************************************
' FILE: 
'			Main.vbs     
' AUTHOR:  
'		   (c) C. Lehmann, 2004
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script is used to load IRRDBU RACF unload
' to an Excel worksheet. The subdirectories are
' fixed. Their name MUST NOT be changed.
' -> Columns: contains record format for each rec.
'    This files have to be regenerated based on
'    racudbld.sql on each OS version change
' -> Headers: contains headers for each rec. type
'    This files have to be regenerated based on
'    racudbld.sql on each OS version change
' -> Irrdbu: contains Irrdbu unload as .txt file
'    after this script's run, will contain also
'    files of record's split by numbers
' -> Scripts: contains scripts invoked from Main
'    as well as the script to load the 
'    structure from racdbuld.
' -> Sql: contains *.sql file, the downloaded 
'    SYS1.SAMPLIB(RACDBULD) sample
'
' CHANGES
' 29th June, 2004: Copied the invocation of irrdbu listing
' procedure once more after split file procedure to 
' prevent empty EXCEL worksheet whenever irrdbu foler 
' is empty
' 1st July, 2004: Added the display of a IE window
' while script is running
'
'************************************************
Option Explicit

' Script variables declaration
Dim scrSPLT_fil		' IRRDBU00 split script
Dim scrEXCL_cre		' EXCEL Create script
Dim scrEXCL_lod		' EXCEL Load Script
Dim scrEXCL_cle		' EXCEL Cleanup script

' Run-time variables
Dim folderspec		' Subfolder specification
Dim aList(100)		' Array containing file names in "Headers"
Dim aHead(100)		' Array containing header from HDR_Tab_nam.txt
Dim oPath			' Path object
Dim sPath			' Path string
Dim sFun			' Function type: Cr, De, Mo, Cl, Ch
Dim oShe			' Wshell object for VBScript launching
Dim iCnt			' Counter
Dim iHdr			' Counter
Dim sNum			' Contains the record number
Dim sHdr			' Contains the worksheet name
Dim n				' Temporary variable
Dim iRetcode		' Return code
Dim objIE		    ' IE object for progression panel

' Get the script's path
oPath = Wscript.ScriptFullName
sPAth = Left(oPath,InStrRev(oPath,"\"))

' Variables for scripts to be invoked later
 scrSPLT_fil = sPath & "\Scripts\scrSPLT_fil.vbs"		' IRRDBU00 split script
 scrEXCL_cre = sPath & "\Scripts\scrEXCL_cre.vbs"		' EXCEL Load script
 scrEXCL_lod = sPath & "\Scripts\scrEXCL_lod.vbs"		' Group Basic Data
 scrEXCL_cle = sPath & "\Scripts\scrEXCL_cle.vbs"		' EXCEL Load script

' Warn the user that EXCEL workbooks will be deleted
n = MsgBox("All Excel Workbooks will be deleted in " & sPath & "! Do you want to continue?", vbYesNo, "File deletion warning")
If n = 7 Then
	WScript.Quit()
End If

' Display a panel stating that the script is running
DisProgPanl()

' And initialise variable to list Irrdbu subfolder
folderspec = sPath & "Irrdbu\"

' Invoke list file subproc. Returns a list of files in the specified folder
ShowfolderList(folderspec)

' Reinitialise variable to list Headers subfoler
folderspec = sPath & "Headers\"

' Invoke header loading subproc
LoaHeadFile(folderspec)

' Creating object for script invocation
Set oShe = WScript.CreateObject("Wscript.Shell")

' Split and recreate the input files, "True" statement is to make Main.vbs
' to wait for invoked script completion.
' The four quotes are required for the case the path contains blanks
iRetcode = oShe.Run ("""" & scrSPLT_fil & """",0,True)
If iRetCode = 12 Then
	WScript.Quit
End If

' Create the EXCEL Workbook, "True" statement is to make Main.vbs
' to wait for invoked script completion.
' The four quotes are required for the case the path contains blanks
iRetcode = oShe.Run ("""" & scrEXCL_cre & """",0,True)
If iRetCode = 12 Then
	WScript.Quit
End If

' Reinitialise variable to list Irrdbu subfolder. This has to be done in case
' the irrdbu folder was originally empty
folderspec = sPath & "Irrdbu\"

' Invoke list file subproc. Returns a list of files in the specified folder
ShowfolderList(folderspec)

' Now loop through the files list and invoke the EXCEL Load script
' and look up in the header list to get the associated Worksheet name
For iCnt = LBound(aList) To UBound(aList)
	n = Right(aList(iCnt),Len(aList(iCnt)) - InStrRev(aList(iCnt),"."))
	If n <> "txt" And n <> "" Then
		sNum = n
		For iHdr = LBound(aHead) To UBound(aHead)
			If InStr(1,aHead(iHdr),sNum) > 0 Then
				sHdr = Mid(aHead(iHdr),6)
				iRetcode = oShe.Run("""" & scrEXCL_lod & """" & " " & sNum & " " & sHdr,0,True)
				If iRetCode = 12 Then
					WScript.Quit
				End If
			End If
		Next
	End If
Next

' Cleanup the EXCEL Workbook, "True" statement is to make Main.vbs
' to wait for invoked script completion.
' The four quotes are required for the case the path contains blanks
iRetcode = oShe.Run ("""" & scrEXCL_cle & """",0,True)
If iRetCode = 12 Then
	WScript.Quit
End If

' Close the panel stating that the script is running
ClosProgPanl()

WScript.Echo "The main.vbs script has ended successfully!"

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s, i
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files		' Get the file object for the specified folder
   For Each f1 in fc
      aList(i) = f1.name	' Loop through the file names and put them in an array to be reused
      i = i + 1
   Next
End Sub

' Subproc to split and create the new files
Sub LoaHeadFile(folderspec)
	Dim fso, ts, fo, s, n, sRec, nPos, i
	Const ForReading = 1
	Const ForAppending = 8
	i = 0
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set ts = fso.OpenTextFile(folderspec & "HDR_Tab_nam.txt",ForReading)
	Do While Not ts.AtEndOfStream
		aHead(i) = ts.Readline	' Read each line from the header file and put them in an array
		i = i + 1
	Loop
	ts.Close
End Sub

' Subproc to display a panel stating that the script is running
Sub DisProgPanl()

' Declare local variables
Dim iSleep
Dim objDoc

iSleep = 500

' Create the IE object
Set objIE = WScript.CreateObject("InternetExplorer.Application", "ie_")

' Set IE object properties
objIE.AddressBar = False
objIE.MenuBar = False
objIE.ToolBar = 0
objIE.Navigate "about:blank"
While objIE.Busy 
	Wscript.Sleep iSleep 
Wend

' Create the IE document objects
Set objDoc = objIE.Document

' Write static properties to the IE document object
objDoc.Write "<HEAD><TITLE>Script running</TITLE></HEAD>"
objDoc.Write "<BODY bgproperties=""fixed"" bgcolor=""#CCCCFF"">"
objDoc.Write "<P><span lang=""fr-ch""><font face=""Arial Black"">dbu2msxl: Scripts to load RACF IRRDBU00 into MS EXCEL</font></span></P><P>"
objDoc.Write "<font face=""Arial"">Please wait for script to complete. This window will close at completion</font></P><blockquote><P>"

' Write static text to the IE document object
objDoc.Write "</blockquote>&nbsp; <span lang=""fr-ch""><font face=""Arial"" size=""1"">Version 1.0.  IBM Global Services, ITS Switzerland, Charles P. Lehmann, 2004</font></span>"

' Set some other document objects properties
objIE.Height = 60 * 2 + 120
objIE.Width = 600
objIE.Visible = True

End Sub 

' Subproc to close the panel stating that the script is running
Sub ClosProgPanl()

' Close the window
objIE.Quit

' Whatever has been chosen, release IE object
Set objIE = Nothing
	
End Sub

'*** End

