'************************************************
' FILE: 
'			scrEXCL_lod.vbs     
' AUTHOR:  
'		   (c) C. Lehmann
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script will cleanup the EXCEL Workbook,
' removing the unused "Sheet#" Worksheet. It 
' will also add the AUTHID worksheet.
'
'************************************************
Option Explicit

Dim folderspec      ' The folder's script
Dim oPath			' Path object
Dim sPath			' Path string
Dim nLeng			' Path length
Dim aList(100)		' Array containing list of files
Dim sFile			' File name
Dim i				' Counter
Dim iFile			' Max number of files
Dim sIrrd			' IRRDBU file name
Dim sExce			' EXCEL Workbook file name
Dim sRecord			' The record type number
Dim sWksnam			' The workheet name

' Get the script's path
oPath = Wscript.ScriptFullName

' First get the path and search Irrdbu folder
nLeng = Len(oPath)
sPAth = Left(oPath,InStrRev(oPath,"\"))
nLeng = Len(sPath)-1
sPAth = Left(sPath,InStrRev(sPath,"\",nLeng))
folderspec = sPath

' Invoke list file subproc
ShowfolderList(folderspec)

' Invoke get EXCEL file name
ExlFileName()

' Invoke list file subproc for IRRDBU source name
folderspec = folderspec & "\Irrdbu\"
ShowfolderList(folderspec)

' Invoke the get IRRDBU file name subproc
SrcFileName()

' Invoke the subproc loading the AUTH_IDS
ExlLoadAuthIDS()

' Invoke the Sheetx cleaning subproc
ExclCleanSheet()

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      aList(i) = f1.name
      iFile = i
      i = i + 1
   Next
End Sub

' Subproc to delete all files with .xls in main folder
Sub DeleteFiles()
	Dim n, fso, f
	Set fso = CreateObject("Scripting.FileSystemObject")
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n="xls" Then
			Set f = fso.GetFile(folderspec & "\" & sFile)
			f.Delete	
		End If
		i = i + 1
	Loop
End Sub

' Subproc to search for source file name
Sub SrcFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "txt" Then
			sIrrd = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to search for EXCEL file name
Sub ExlFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "xls" Then
			sExce = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to load the AUTH_IDS
Sub ExlLoadAuthIDS()
	Dim objXL, objWb, objWs, objR, objTab, objRange, objCell, fso, s, n, sRec, nPos, sColumn, sDispo, aColumn, aDispo, oAfter, i
	Const ForReading = 1
	Const vbNormal = 1
	Set fso = CreateObject("Scripting.FileSystemObject")

	On Error Resume Next
	Set objXL = GetObject(,"Excel.Application")
	If Err Then
		Set objXL = WScript.CreateObject ("Excel.Application")
	Else
		WScript.Echo "An EXCEL instance has been found running on your workstation. Please save and close it and rerun the script!"
		WScript.Quit(12)
	End If
	
	Set objWb = objXl.WorkBooks.Open (sPath & sExce)
	n = objXL.ActiveWorkBook.WorkSheets.Count
	Set oAfter = objXL.ActiveWorkBook.Sheets(n)
	Set objWs = objXL.ActiveWorkBook.WorkSheets.Add(,oAfter)
	objWs.Name = "AUTH_IDS"
	objWs.Activate
	objWs.Cells(1,1).Value = "AUTHID_NAME"
	Set objRange = objWs.Cells(1,1).EntireRow
	objRange.Font.Bold = True
	
	If fso.FileExists(sPath & "Irrdbu/" & sIrrd & ".0100") Then	
		Set objTab = objWs.QueryTables.Add ("TEXT;" & sPath & "Irrdbu/" & sIrrd & ".0100", objWs.Range("A2"))
		objTab.Name = "RACF"
		objTab.FieldNames = True
		objTab.RowNumbers = False
		objTab.FillAdjacentFormulas = False
		objTab.PreserveFormatting = True
		objTab.RefreshOnFileOpen = False
		objTab.RefreshStyle = 1
		objTab.SavePassword = False
		objTab.SaveData = True
		objTab.AdjustColumnWidth = True
		objTab.RefreshPeriod = 0
		objTab.TextFilePromptOnRefresh = False
		objTab.TextFilePlatform = 2
		objTab.TextFileStartRow = 1
		objTab.TextFileParseType = 2
		objTab.TextFileFixedColumnWidths = Array(5,8)
		objTab.TextFileColumnDataTypes = Array(9,1,9)
		objTab.Refresh True
	End If	
	i = 0
	Set objRange = objWs.Cells(1,1).EntireColumn
	For Each objCell In objRange.Cells
		If objCell.Value = "" Then
			Exit For
		End If
		i = i + 1
	Next
	
	i = i + 1
	
	If fso.FileExists(sPath & "Irrdbu/" & sIrrd & ".0200") Then	
		Set objTab = objWs.QueryTables.Add ("TEXT;" & sPath & "Irrdbu/" & sIrrd & ".0200", objWs.Range("A" & i))
		objTab.Name = "RACF"
		objTab.FieldNames = True
		objTab.RowNumbers = False
		objTab.FillAdjacentFormulas = False
		objTab.PreserveFormatting = True
		objTab.RefreshOnFileOpen = False
		objTab.RefreshStyle = 1
		objTab.SavePassword = False
		objTab.SaveData = True
		objTab.AdjustColumnWidth = True
		objTab.RefreshPeriod = 0
		objTab.TextFilePromptOnRefresh = False
		objTab.TextFilePlatform = 2
		objTab.TextFileStartRow = 1
		objTab.TextFileParseType = 2
		objTab.TextFileFixedColumnWidths = Array(5,8)
		objTab.TextFileColumnDataTypes = Array(9,1,9)
		objTab.Refresh True
	End If
	
	objWb.Save
	objWb.Close
End Sub

' Subproc to delete ununsed default sheets (Sheet1..3)
Sub ExclCleanSheet()
	Dim objXL, objWb, objWs, objR, oAfter, nSheetx
	Set objXL = WScript.CreateObject ("Excel.Application")
	Set objWb = objXl.WorkBooks.Open (sPath & sExce & ".xls")
	For Each objWs In objWb.Sheets
		nSheetx = InStr(1,objWs.Name,"Sheet")
		If nSheetx <> 0 Then
			objWb.Sheets(objWs.Name).Delete
			nSheetx = 0
		End If
	Next
	Set objWs = objXL.ActiveWorkBook.Sheets(1)
	objWs.Activate
	objWb.Save
	objWb.Close
End Sub

' *** END