'************************************************
' FILE: 
'			scrEXCL_cre.vbs     
' AUTHOR:  
'		   (c) C. Lehmann
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script is used to delete existing previous
' EXCEL workbook and create a new one 
' to recreate the same files.
' The workbook is in the upper folder
'
'************************************************
Option Explicit

Dim folderspec      ' The folder's script
Dim oPath			' Path object
Dim sPath			' Path string
Dim nLeng			' Path length
Dim aList(100)		' Array containing list of files
Dim sFile			' File name
Dim i				' Counter
Dim iFile			' Max number of files
Dim sIrrd			' IRRDBU file name

' Get the script's path
oPath = Wscript.ScriptFullName

' First get the path and search the associated folders
nLeng = Len(oPath)
sPAth = Left(oPath,InStrRev(oPath,"\"))
nLeng = Len(sPath)-1
sPAth = Left(sPath,InStrRev(sPath,"\",nLeng))
folderspec = sPath

' Invoke list file subproc for IRRDBU source name
ShowfolderList(folderspec)

' Invoke delete file subproc
DeleteFiles()

' Invoke list file subproc for IRRDBU source name
folderspec = folderspec & "\Irrdbu\"
ShowfolderList(folderspec)

'Invoke the file name subproc
SrcFileName()

' Invke the source reading and spliting subproc
folderspec = sPath
ExlCreaFile(folderspec)

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      aList(i) = f1.name
      iFile = i
      i = i + 1
   Next
End Sub

' Subproc to delete all files with .xls in irrdbu folder
Sub DeleteFiles()
	Dim n, fso, f
	Set fso = CreateObject("Scripting.FileSystemObject")
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "xls" Then
			Set f = fso.GetFile(folderspec & "\" & sFile)
			On Error Resume Next
			f.Delete
			If Err Then
				WScript.Echo "An EXCEL instance has been found running on your workstation. Please save and close it and rerun the script!"
				WScript.Quit(12)
			End If
		End If	
		i = i + 1
	Loop
End Sub

' Subproc to search for source file name
Sub SrcFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "txt" Then
			sIrrd = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to create the new workbook
Sub ExlCreaFile(folderspec)
	Dim objXL, objWb, objR, objTab
	On Error Resume Next
	Set objXL = GetObject(,"Excel.Application")
	If Err Then
		Set objXL = WScript.CreateObject ("Excel.Application")
	Else
		WScript.Echo "An EXCEL instance has been found running on your workstation. Please save and close it and rerun the script!"
		WScript.Quit(12)
	End If
	Set objWb = objXl.WorkBooks.Add
	objWb.SaveAs(folderspec & sIrrd & ".xls")
	objWb.Close
End Sub

' *** END