'************************************************
' FILE: 
'			scrEXCL_lod.vbs     
' AUTHOR:  
'		   (c) C. Lehmann
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script will load the previously allocated
' EXCEL workbook. The worksheets added are based
' on passed parameters.
'
'************************************************
Option Explicit

Dim folderspec      ' The folder's script
Dim oPath			' Path object
Dim sPath			' Path string
Dim nLeng			' Path length
Dim aList(100)		' Array containing list of files
Dim sFile			' File name
Dim i				' Counter
Dim iFile			' Max number of files
Dim sIrrd			' IRRDBU file name
Dim sExce			' EXCEL Workbook file name
Dim sRecord			' The record type number
Dim sWksnam			' The workheet name

' Check whether arguments were provided
If WScript.Arguments.Count = 0 or WScript.Arguments.Count > 2 Then
	WScript.Echo "Usage: scrEXCL_lod.vbs recnumber sheetname"
	WScript.Quit
End If

' Get the passed arguments
sRecord = WScript.Arguments.Item(0)
sWksnam = WScript.Arguments.Item(1)

' Get the script's path
oPath = Wscript.ScriptFullName

' First get the path and search Irrdbu folder
nLeng = Len(oPath)
sPAth = Left(oPath,InStrRev(oPath,"\"))
nLeng = Len(sPath)-1
sPAth = Left(sPath,InStrRev(sPath,"\",nLeng))
folderspec = sPath

' Invoke list file subproc
ShowfolderList(folderspec)

' Invoke get EXCEL file name
ExlFileName()

' Invoke list file subproc for IRRDBU source name
folderspec = folderspec & "\Irrdbu\"
ShowfolderList(folderspec)

' Invoke the get IRRDBU file name subproc
SrcFileName()

' Invoke the worksheet loading subproc
ExlLoadFile()

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      aList(i) = f1.name
      iFile = i
      i = i + 1
   Next
End Sub

' Subproc to delete all files with .xls in main folder
Sub DeleteFiles()
	Dim n, fso, f
	Set fso = CreateObject("Scripting.FileSystemObject")
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n="xls" Then
			Set f = fso.GetFile(folderspec & "\" & sFile)
			f.Delete	
		End If
		i = i + 1
	Loop
End Sub

' Subproc to search for source file name
Sub SrcFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "txt" Then
			sIrrd = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to search for EXCEL file name
Sub ExlFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		If n = "xls" Then
			sExce = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to load the new workbook
Sub ExlLoadFile()
	Dim objXL, objWb, objWs, objR, objTab, objRange, fso, ts, fo, s, n, sRec, nPos, sColumn, sDispo, aColumn, aDispo, oAfter
	Const ForReading = 1
	Const vbNormal = 1
	Set fso = CreateObject("Scripting.FileSystemObject")
	If Not (fso.FileExists(sPath & "Columns\COL" & sRecord & ".txt")) Then
		WScript.Echo "Inconsistency has been found with the RACF Database Structure against the unloaded IRRDBU00 file. " _ 
		& "Please do the following:      " _ 
		& "1) Get a SYS1.SAMPLIB(RACDBULD) copy corresponding to the IRRDBU   " _ 
		& "2) Transfer it into <Path>\Sql\racdbuld.sql   " _ 
		& "3) Run <Path>\Scripts\scrSQLS_cre.vbs   " _ 
		& "4) Run this script again"
		WScript.Quit(12) 
	End If
	Set ts = fso.OpenTextFile(sPath & "Columns\COL" & sRecord & ".txt",ForReading)
	sColumn = ts.Readline
	sDispo = ts.Readline
	ts.Close	
	
	On Error Resume Next
	Set objXL = GetObject(,"Excel.Application")
	If Err Then
		Set objXL = WScript.CreateObject ("Excel.Application")
	Else
		WScript.Echo "An EXCEL instance has been found running on your workstation. Please save and close it and rerun the script!"
		WScript.Quit(12)
	End If
	
	Set objWb = objXl.WorkBooks.Open (sPath & sExce & ".xls")
	n = objXL.ActiveWorkBook.WorkSheets.Count
	Set oAfter = objXL.ActiveWorkBook.Sheets(n)
	Set objWs = objXL.ActiveWorkBook.WorkSheets.Add(,oAfter)
	objWs.Name = sWksnam
	objWs.Activate
	Set objTab = objWs.QueryTables.Add ("TEXT;" & sPath & "Headers/HDR" & sRecord & ".txt", objWs.Range("A1"))
	objTab.Name = "RACF"
	objTab.FieldNames = True
	objTab.RowNumbers = False
	objTab.FillAdjacentFormulas = False
	objTab.PreserveFormatting = True
	objTab.RefreshOnFileOpen = False
	objTab.RefreshStyle = 1
	objTab.SavePassword = False
	objTab.SaveData = True
	objTab.AdjustColumnWidth = True
	objTab.RefreshPeriod = 0
	objTab.TextFilePromptOnRefresh = False
	objTab.TextFilePlatform = 2
	objTab.TextFileStartRow = 1
	objTab.TextFileParseType = 1
	objTab.TextFileTextQualifier = -4142
	objTab.TextFileConsecutiveDelimiter = False
	objTab.TextFileTabDelimiter = True
	objTab.TextFileSemicolonDelimiter = True
	objTab.TextFileCommaDelimiter = True
	objTab.TextFileSpaceDelimiter = False
	objTab.TextFileColumnDataTypes = Array(1, 1)
	objTab.Refresh True
	aColumn = Split(sColumn, ",", -1, 1)
	For i = LBound(aColumn) To UBound(aColumn)
		aColumn(i) = CInt(aColumn(i))
	Next
	aDispo = Split(sDispo, "," , -1, 1)
	For i = LBound(aDispo) To UBound(aDispo)
		aDispo(i) = CInt(aDispo(i))
	Next

	Set objTab = objWs.QueryTables.Add ("TEXT;" & sPath & "Irrdbu/" & sIrrd & "." & sRecord, objWs.Range("A2"))
	objTab.Name = "RACF"
	objTab.FieldNames = True
	objTab.RowNumbers = False
	objTab.FillAdjacentFormulas = False
	objTab.PreserveFormatting = True
	objTab.RefreshOnFileOpen = False
	objTab.RefreshStyle = 1
	objTab.SavePassword = False
	objTab.SaveData = True
	objTab.AdjustColumnWidth = True
	objTab.RefreshPeriod = 0
	objTab.TextFilePromptOnRefresh = False
	objTab.TextFilePlatform = 2
	objTab.TextFileStartRow = 1
	objTab.TextFileParseType = 2
	objTab.TextFileFixedColumnWidths = aColumn
	objTab.TextFileColumnDataTypes = aDispo
	objTab.Refresh True
	
	Set objRange = objWs.Cells(1,1).EntireRow
	objRange.Font.Bold = True	

	objWb.Save
	objWb.Close
End Sub

' *** END