'************************************************
' FILE: 
'			scrSPLT_fil.vbs     
' AUTHOR:  
'		   (c) C. Lehmann
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script is used to delete all files 
' defined in previous runs of the same script and
' to recreate the same files.
' The input file must be *.txt in ..\Irrdbu 
' folder. The output files are a split of the 
' irrdbu text file, based on the record number.
' The format is <Inputfilename>.<Recordno>.
' Example: Irrdbu.0102
'
'************************************************
Option Explicit

Dim folderspec      ' The folder's script
Dim oPath			' Path object
Dim sPath			' Path string
Dim nLeng			' Path length
Dim aList(100)		' Array containing list of files
Dim sFile			' File name
Dim i				' Counter
Dim iFile			' Max number of files
Dim sIrrd			' IRRDBU file name

' Get the script's path
oPath = Wscript.ScriptFullName

' First get the path and search Irrdbu folder
nLeng = Len(oPath)
sPAth = Left(oPath,InStrRev(oPath,"\"))
nLeng = Len(sPath)-1
sPAth = Left(sPath,InStrRev(sPath,"\",nLeng))
folderspec = sPath & "Irrdbu"

' Invoke list file subproc
ShowfolderList(folderspec)

' Invoke delete file subproc
DeleteFiles()

' Invoke the get IRRDBU file name subproc
SrcFileName()

' Invoke the source reading and spliting subproc
SplCreaFile()

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      aList(i) = f1.name
      iFile = i
      i = i + 1
   Next
End Sub

' Subproc to delete all files with .### in irrdbu folder
Sub DeleteFiles()
	Dim n, fso, f
	Set fso = CreateObject("Scripting.FileSystemObject")
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = Right(sFile,Len(sFile) - InStrRev(sFile,"."))
		n = Left(n,2)
		If IsNumeric(n) Then
			Set f = fso.GetFile(folderspec & "\" & sFile)
			f.Delete	
		End If
		i = i + 1
	Loop
End Sub

' Subproc to search for source file name
Sub SrcFileName()
	Dim n, nTxtFil
	i = 0
	nTxtFil = 0
	Do While i <= iFile
		sFile = aList(i)
		n = LCase(Right(sFile,Len(sFile) - InStrRev(sFile,".")))
		If n = "txt" Then
			If LCase(sFile) <> sFile Then
				RenameFile LCase(sFile),sFile
				sFile = LCase(sFile)
			End If
			sIrrd = Left(sFile,InStrRev(sFile,".")-1)
			nTxtFil = nTxtFil + 1
		End If
		i = i + 1
	Loop
	If nTxtFil > 1 Then
		WScript.Echo "More than one .txt files have been found in \Irrdbu subfoler. Please delete all unused ones!"
		WScript.Quit(12)
	End If
	
End Sub

' Subproc to split and create the new files
Sub SplCreaFile()
	Dim fso, ts, fo, s1, s2, n1, n2, sRec, nPos
	Const ForReading = 1
	Const ForAppending = 8
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set ts = fso.OpenTextFile(folderspec & "\" & sIrrd & ".txt",ForReading)
	Do While Not ts.AtEndOfStream
		s1 = ts.Readline				' Read two lines in case the lines
		If Not ts.AtEndOfStream Then	' are split (special characters)
			s2 = ts.Readline
		Else
			s2 = ""
		End If
		n1 = Left(s1,4)
		n2 = Left(s2,4)
		If IsNumeric(Right(n1,1)) And IsNumeric(Left(n1,2)) Then
			If IsNumeric(Right(n2,1)) And IsNumeric(Left(n2,2)) Then
				nPos = InStr(sRec,n1)
				If nPos <> 0 Then
					Set fo = fso.OpenTextFile(folderspec & "\" & sIrrd & "." & n1,ForAppending)
					fo.Writeline s1
					fo.Close
				Else
					Set fo = fso.CreateTextFile(folderspec & "\" & sIrrd & "." & n1)
					fo.Writeline s1
					fo.Close
					sRec = sRec & "," & n1
				End If

				nPos = InStr(sRec,n2)
				If nPos <> 0 Then
					Set fo = fso.OpenTextFile(folderspec & "\" & sIrrd & "." & n2,ForAppending)
					fo.Writeline s2
					fo.Close
				Else
					Set fo = fso.CreateTextFile(folderspec & "\" & sIrrd & "." & n2)
					fo.Writeline s2
					fo.Close
					sRec = sRec & "," & n2
				End If

			Else		' If the first line has num and the second not 
				nPos = InStr(sRec,n1)	' concatenate and write
				s1 = s1 & s2
				If nPos <> 0 Then
					Set fo = fso.OpenTextFile(folderspec & "\" & sIrrd & "." & n1,ForAppending)
					fo.Writeline s1
					fo.Close
				Else
					Set fo = fso.CreateTextFile(folderspec & "\" & sIrrd & "." & n1)
					fo.Writeline s1
					fo.Close
					sRec = sRec & "," & n1
				End If

			End If	
		End If 
	Loop
	ts.Close
End Sub

' Subproc to rename the file
Sub RenameFile(ssFile, ssOldfile)
	Dim objShell
        set objShell = CreateObject("Shell.Application")
        if (not objShell is nothing) then
            dim objFolder2
                
            set objFolder2 = objShell.NameSpace(folderspec)
            if (not objFolder2 is nothing) then
                dim objFolderItem
                        
                set objFolderItem = objFolder2.ParseName(ssOldfile)
                if (not objFolderItem is nothing) then
                    dim szReturn                               
                    szReturn = objFolderItem.Name
                    objFolderItem.Name = ssFile
                end if
                set objFolderItem = nothing
            end if
            set objFolder2 = nothing
        end if
        set objShell = nothing
End Sub

' *** END