'************************************************
' FILE: 
'			scrSQLS_cre.vbs     
' AUTHOR:  
'		   (c) C. Lehmann
'          Advisory IT Architect
'          IBM Global Services, Geneva
'
' PURPOSE OF SCRIPT:
' This script is used to delete all header and
' columns information files located in Columns 
' and Headers subfolders.
' It will then recreate these files based on 
' ..\Sql\racdbuld.sql file. This file has to 
' be downloaded from SYS1.SAMPLIB(RACDBULD) 
' each time a new version of OS/390 or z/OS is
' installed. (In fact, only when major RACF 
' changes have been provided... but it is always
' better to have belt and braces...)
' 
'************************************************
Option Explicit

Dim folderspec      ' The folder's script
Dim oPath			' Path object
Dim sPath			' Path string
Dim nLeng			' Path length
Dim aList(100)		' Array containing list of files
Dim sFile			' File name
Dim i				' Counter
Dim iFile			' Max number of files
Dim sIrrd			' IRRDBU file name

' Get the script's path
oPath = Wscript.ScriptFullName

' First get the path and search the associated folders
nLeng = Len(oPath)
sPAth = Left(oPath,InStrRev(oPath,"\"))
nLeng = Len(sPath)-1
sPAth = Left(sPath,InStrRev(sPath,"\",nLeng))

' Invoke list file subproc for IRRDBU source name
folderspec = sPath & "\Columns\"
ShowfolderList(folderspec)

' Invoke delete file subproc
DeleteFiles()

' Invoke list file subproc for IRRDBU source name
folderspec = sPath & "\Headers\"
ShowfolderList(folderspec)

' Invoke delete file subproc
DeleteFiles()

' Invoke list file subproc for IRRDBU source name
folderspec = sPath & "Sql\"
ShowfolderList(folderspec)

'Invoke the file name subproc
SrcFileName()
If sIrrd = Null Then
	Wscript.Echo "racdbu.sql file has not been found in ..\Sql\ folder. Please correct!"
	Wscript.Quit
End If

' Invke the source reading and spliting subproc
SplCreaFile()

WScript.Echo "The script generating the headers and columns information has successfully ended!"

' Subproc to list the files in irrdbu folder
Sub ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   i = 0
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      aList(i) = f1.name
      iFile = i
      i = i + 1
   Next
End Sub

' Subproc to delete all files in specified subfolder
Sub DeleteFiles()
	Dim fso, f
	Set fso = CreateObject("Scripting.FileSystemObject")
	If iFile <> 0 Then
		i = 0
		Do While i <= iFile
			sFile = aList(i)
			Set f = fso.GetFile(folderspec & "\" & sFile)
			f.Delete	
			i = i + 1
		Loop
	End If
End Sub

' Subproc to search for source file name
Sub SrcFileName()
	Dim n
	i = 0
	Do While i <= iFile
		sFile = aList(i)
		n = LCase(Right(sFile,Len(sFile) - InStrRev(sFile,".")))
		If n = "sql" Then
			If LCase(sFile) <> sFile Then
				RenameFile LCase(sFile),sFile
				sFile = LCase(sFile)
			End If
			sIrrd = Left(sFile,InStrRev(sFile,".")-1)
		End If
		i = i + 1
	Loop
End Sub

' Subproc to split and create the new files
Sub SplCreaFile()
	Dim fso, ts, fo, s, n, nTabnam, sTabnam, nTabnum, sTabnum, nColnum, nColnam
	Dim foTab, foCol, foHdr, sCol, sColwidth, sColusage, sHeader
	Dim nLbnd, nUbnd, nPUbnd, ss, i, nNuswidth, nUswidth
	Dim nBlank
	Const ForReading = 1
	Const ForAppending = 8
	nTabnam = 0
	nTabnum = 0
	nColnum = 0
	nPUbnd = 0
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set ts = fso.OpenTextFile(sPath & "\Sql\" & sIrrd & ".sql",ForReading)
	Set foTab = fso.CreateTextFile(sPath & "Headers\HDR_Tab_nam.txt")
	foTab.Close 
	Do While Not ts.AtEndOfStream
		s = ts.Readline
		nTabnam = InStr(1,s,"INTO TABLE")
		If nTabnam <> 0 Then 
			sTabnam = Mid(s,InStr(s,".")+1)
			nBlank = Instr(sTabnam," ")
			If nBlank <> 0 Then
				sTabnam = Mid(sTabnam,1,InStr(sTabnam," ")-1)
			Else
				sTabnam = RTrim(sTabnam)
			End If
			If nPUbnd <> 0 And sTabnam <> "AUTH_IDS" Then
				Set foCol = fso.CreateTextFile(sPath & "Columns\COL" & sTabnum & ".txt") 
				foCol.Writeline sColwidth
				foCol.Writeline sColusage
				foCol.Close
				Set foHdr = fso.CreateTextFile(sPath & "Headers\HDR" & sTabnum & ".txt")
				foHdr.Writeline sHeader
				foHdr.Close
				sHeader = Null
				sColwidth = Null
				sColusage = Null
				nPUbnd = 0
				i = 0
			End If
			nTabnum = 0
		End If
		nTabnum = InStr(1,s,"WHEN(1:4)=")
		If nTabnum <> 0 Then
			sTabnum = Mid(s,InStr(s,"'")+1,4)
			If sTabnam <> "AUTH_IDS" Then
				Set foTab = fso.OpenTextFile(sPath & "Headers\HDR_Tab_nam.txt",ForAppending)
				foTab.Writeline sTabnum & "," & sTabnam
				foTab.Close
			End If
			nTabnum = 0
		End If
		nColnum = InStr(1,s,"POSITION")
		If nColnum <> 0 Then
			i = i + 1
			ss = RTrim(Mid(s,7,20))
			nColnum = InStr(1,s,"(")
			nLbnd = Mid(s,nColnum + 1,InStr(1,s,":")-nColnum-1)
			nColnum = InStr(1,s,":")
			nUbnd = Mid(s,nColnum + 1,InStr(1,s,")")-nColnum-1)
			nLbnd = CInt(nLbnd)
			nUbnd = CInt(nUbnd)
			If i = 1 Then
				nUswidth = nUbnd - nLbnd + 1
				nNuswidth = nLbnd - 5
				sHeader = ss
				sColwidth = "4" & "," & nNuswidth & "," & nUswidth 
				sColusage = "9,9,1"
			Else
				nUswidth = nUbnd - nLbnd + 1
				nNuswidth = nLbnd - nPUbnd -1
				sHeader = sHeader & "," & ss
				sColwidth = sColwidth & "," & nNuswidth & "," & nUswidth
				sColusage = sColusage & ",9,1"
			End If
			nPUbnd = nUbnd
			nColnum = 0
		End If
	Loop
	ts.Close
End Sub

' Subproc to rename the file
Sub RenameFile(ssFile, ssOldfile)
	Dim objShell
        set objShell = CreateObject("Shell.Application")
        if (not objShell is nothing) then
            dim objFolder2
                
            set objFolder2 = objShell.NameSpace(folderspec)
            if (not objFolder2 is nothing) then
                dim objFolderItem
                        
                set objFolderItem = objFolder2.ParseName(ssOldfile)
                if (not objFolderItem is nothing) then
                    dim szReturn                               
                    szReturn = objFolderItem.Name
                    objFolderItem.Name = ssFile
                end if
                set objFolderItem = nothing
            end if
            set objFolder2 = nothing
        end if
        set objShell = nothing
End Sub

' *** END